#include <SDL/SDL.h>
#include <stdlib.h>

#include "sier3.h"

#define NODES 4 /* dimensions+1 */ /* don't change this */


#define POINTS (MAX_X*MAX_Y*4/INC)
#define get_rand random()

main()
{
  SDL_Surface *screen;
  SDL_Color palette[256];
  SDL_Event event;
  unsigned char *pixels,*k;
  int i,pitch;
  int rand=0;
  int frames=0;
  int starttime;

  struct _point
  {
    int x;
    int y;
    int dx;
    int dy;
  }
  coords[NODES],*j;
  int off[NODES];

  SDL_Init(SDL_INIT_VIDEO);
  screen=SDL_SetVideoMode(MAX_X,MAX_Y,8,0/*|SDL_DOUBLEBUF|SDL_HWSURFACE*/);
  atexit(SDL_Quit);
  starttime=SDL_GetTicks();

  for(i=0,j=coords;i<=NODES;i++,j++)
	{
	  j->x=(get_rand % MAX_X);
	  j->y=(get_rand % MAX_Y);
	  j->dx=(get_rand%9)-5;
	  j->dy=(get_rand%9)-5;
	  off[i]=0;
	}

#if 0
  for(i=0;i<64;i++)
    {
      palette[127-i].r=(63-i)<<2;
      palette[127-i].g=i<<1;
      palette[127-i].b=0;
      palette[63-i].r=i<<2;
      palette[63-i].g=(64+i)<<1;
      palette[63-i].b=i<<2;
    }
  for(i=0;i<128;i++)
    {
      palette[255-i].r=i<<1;
      palette[255-i].g=0;
      palette[255-i].b=0;
    }
#else 
  {
    int q=255/INC/C;
  for(i=0;i<q;i++)
    {
      palette[i].r=i*INC*R*C;
      palette[i].g=i*INC*G*C;
      palette[i].b=i*INC*B*C;
    }
  for(i=q;i<256;i++)
    {
      palette[i].r=R*255;
      palette[i].g=G*255;
      palette[i].b=B*255;
    }
  }
#endif

  SDL_SetColors(screen,palette,0,256);
  
  printf("%d points\n",POINTS);

  for(;;)
    {
      int i;


      //      SDL_LockSurface(screen);
      pixels=screen->pixels;
      pitch=screen->pitch;
            SDL_FillRect(screen,NULL,0);

#if 0
for(i=0;i<256;i++)
  {
    pixels[i]=i;
    pixels[i+pitch]=i;
  }
#endif

#ifndef SPEEDY_ASM

#define random2() \
(seed+=((seed<<13)+(seed>>19)))

 {
   /* x,y,seed,mask,coords,i,pixels */
     
      unsigned int seed=0x12345678;
      int x=0,y=0,j;
      int mask=~pitch;
      for(i=POINTS;i--;)
	{
	  j=(random2()%NODES);
	  //	  x=(old*x+new*j->x)/(old+new);
	  //	  y=(old*y+new*j->y)/(old+new);

	  y=((y&mask)+off[j])/2;
	  
	  //	  printf("x=%i, y=%i, j=%i,mask=%p\n",x,y,j-coords,j->y2);
	  
	  if (!++pixels[y])
	    pixels[y]=255;

	}
 }
#else

 plot(off,pixels,POINTS,~pitch); 
#endif
      //      SDL_UnlockSurface(screen);
      SDL_Flip(screen);
      frames++;
      for(i=0,j=coords;i<NODES;i++,j++)
	{
	  if (((j->x+j->dx)<0)||((j->x+j->dx)>MAX_X)) j->dx=-j->dx;
	  if (((j->y+j->dy)<0)||((j->y+j->dy)>MAX_Y)) j->dy=-j->dy;
	  j->x+=j->dx;
	  j->y+=j->dy;
	  off[i]=j->x+(j->y&~1)*pitch;
	}
      while(SDL_PollEvent(&event))
	{
	  switch (event.type)
	    {
	    case SDL_MOUSEBUTTONDOWN:
	    case SDL_QUIT:
	      printf("%f fps\n", 1000*frames/(double)(SDL_GetTicks()-starttime));
	      exit(0);
	    }
	}
    }
}
